;Program compiled by Great Cow BASIC (0.98.06 2019-06-12 (Windows 32 bit))
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=12F675, r=DEC
#include <P12F675.inc>
 __CONFIG _CP_OFF & _MCLRE_OFF & _WDTE_OFF & _INTRC_OSC_NOCLKOUT

;********************************************************************************

;Set aside memory locations for variables
AUXA	EQU	33
AUXB	EQU	34
AUXC	EQU	35
CMCOM	EQU	36
CNT	EQU	39
DELAYTEMP	EQU	32
GER	EQU	40
PROC	EQU	42
SAVEPCLATH	EQU	43
SAVESYSBYTETEMPA	EQU	44
SAVESYSBYTETEMPB	EQU	45
SAVESYSBYTETEMPX	EQU	48
SAVESYSTEMP1	EQU	49
SAVESYSTEMP2	EQU	50
SAVESYSTEMP3	EQU	51
SYSBYTETEMPA	EQU	37
SYSBYTETEMPB	EQU	41
SYSBYTETEMPX	EQU	32
SYSSTATUS	EQU	47
SYSTEMP1	EQU	52
SYSTEMP2	EQU	53
SYSTEMP3	EQU	54
SYSW	EQU	46
SYSWAITTEMPUS	EQU	37
SYSWAITTEMPUS_H	EQU	38

;********************************************************************************

;Vectors
	ORG	0
	pagesel	BASPROGRAMSTART
	goto	BASPROGRAMSTART
	ORG	4
Interrupt

;********************************************************************************

;Save Context
	movwf	SysW
	swapf	STATUS,W
	movwf	SysSTATUS
	banksel	STATUS
;Store system variables
	movf	SysByteTempB,W
	movwf	SaveSysByteTempB
	movf	SysByteTempA,W
	movwf	SaveSysByteTempA
	movf	SysByteTempX,W
	movwf	SaveSysByteTempX
	movf	SysTemp1,W
	movwf	SaveSysTemp1
	movf	SysTemp2,W
	movwf	SaveSysTemp2
	movf	SysTemp3,W
	movwf	SaveSysTemp3
	movf	PCLATH,W
	movwf	SavePCLATH
	clrf	PCLATH
;On Interrupt handlers
	banksel	PIE1
	btfss	PIE1,TMR1IE
	goto	NotTMR1IF
	banksel	PIR1
	btfss	PIR1,TMR1IF
	goto	NotTMR1IF
	call	ISR_TIMER1
	bcf	PIR1,TMR1IF
	goto	INTERRUPTDONE
NotTMR1IF
;User Interrupt routine
INTERRUPTDONE
;Restore Context
;Restore system variables
	movf	SaveSysByteTempB,W
	movwf	SysByteTempB
	movf	SaveSysByteTempA,W
	movwf	SysByteTempA
	movf	SaveSysByteTempX,W
	movwf	SysByteTempX
	movf	SaveSysTemp1,W
	movwf	SysTemp1
	movf	SaveSysTemp2,W
	movwf	SysTemp2
	movf	SaveSysTemp3,W
	movwf	SysTemp3
	movf	SavePCLATH,W
	movwf	PCLATH
	swapf	SysSTATUS,W
	movwf	STATUS
	swapf	SysW,F
	swapf	SysW,W
	retfie
	banksel	STATUS

;********************************************************************************

;Start of program memory page 0
	ORG	57
BASPROGRAMSTART
;Call initialisation routines
	call	INITSYS
;Enable interrupts
	bsf	INTCON,GIE
	bsf	INTCON,PEIE

;Start of the main program
;*******************************************************************************
;SINALIZADOR DE MARCHA R COM EFEITOS LUMINOSOS E SIRENE
;C/ PIC12F675
;AUTOR: CLAUDIO LARIOS
;DATA:22/12/2020
;Dever ser ligado junto as lmpadas de r do veculo
;Use Great Cow Basic Compiler
;USO DIDTICO
;ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG LARIOS.TECNOLOGIA.WS
;*******************************************************************************/
;#define piezo     GPIO.2 'pino 5
;Dir     piezo     out
	banksel	TRISIO
	bcf	TRISIO,2
;#define gled1     GPIO.5 'pino 2
;Dir     gled1    out
	bcf	TRISIO,5
;#define gled2     GPIO.4 'pino 3
;Dir     gled2    out
	bcf	TRISIO,4
;variveis globais
;Dim cnt as byte
;Dim auxa as byte
;Dim auxb as byte
;Dim auxc as byte
;Dim auxd as byte
;Dim auxe as byte
;Dim auxj as byte
;Dim cnt as byte
;Dim vez as Byte
;Dim ger as Byte : ger = 0
	clrf	GER
;Dim proc as Byte: proc = 0
	clrf	PROC
;*******************************************************************************
;SUBROTINAS
;*******************************************************************************/
;*******************************************************************************
;Rotina de Interrupo do Timer 1
;*******************************************************************************/
;On interrupt Timer1Overflow Call   ISR_TIMER1
	bsf	PIE1,TMR1IE
;*******************************************************************************
;ROTINA MAIN
;******************************************************************************/
;CMCOM = 7'desliga comparadores
	movlw	7
	movwf	CMCOM
;GPIO = 0'zera tudo
	banksel	GPIO
	clrf	GPIO
;TRISIO = 0b001011'ajusta entradas e sadas
	movlw	11
	banksel	TRISIO
	movwf	TRISIO
;ANSEL = 0'desabilita ports p/ conversores ADC
	clrf	ANSEL
;T1CON = 0x01'liga timer1  prescaller/8
	movlw	1
	banksel	T1CON
	movwf	T1CON
;TMR1IF = 0
	bcf	PIR1,TMR1IF
;TMR1H = 0Xd8'carga para 10 ms
	movlw	216
	movwf	TMR1H
;TMR1L = 0Xef
	movlw	239
	movwf	TMR1L
;WPU = 0X3F
	movlw	63
	banksel	WPU
	movwf	WPU
;OPTION_REG = 0
	clrf	OPTION_REG
;PIE1 = 1'liga interrupo do timer 1
	movlw	1
	movwf	PIE1
;INTCON = 0B11000000'GIE=1 /PEIE=1 //liga interrupo
	movlw	192
	movwf	INTCON
;*******************************************************************************
;LOOP PRINCIPAL DE REPETIO
;*******************************************************************************/
;do
SysDoLoop_S1
;som_sirene18
	banksel	STATUS
	call	SOM_SIRENE18
;loop
	goto	SysDoLoop_S1
SysDoLoop_E1
;-----------------------fim do programa -------------------------------
BASPROGRAMEND
	sleep
	goto	BASPROGRAMEND

;********************************************************************************

INITSYS
;Resolve OSCCAL calibration
;GCB does not load saved calibration data into OSCCAL register on Baseline PIC. Therefore the FOSC is inaccurate when using internal RC oscillator.
;Solution:  Add following as the FIRST lines in the INITSYS sub in the System.h file
;This loads the saved calibration data from the last flash memory location at POR or any time the chip is reset.
;CALL 0x3ff
	call	1023
;movwf osccal
	banksel	OSCCAL
	movwf	OSCCAL
;Set up internal oscillator
;Handle OSCCON1 register for parts that have this register
;Ensure all ports are set for digital I/O and, turn off A/D
;SET ADFM OFF
	banksel	ADCON0
	bcf	ADCON0,ADFM
;Switch off A/D Var(ADCON0)
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON
;Commence clearing any ANSEL variants in the part
;ANSEL = 0
	banksel	ANSEL
	clrf	ANSEL
;End clearing any ANSEL variants in the part
;Turn off comparator - this is the default setting
;CMCON = 7
	movlw	7
	banksel	CMCON
	movwf	CMCON
;Turn off all ports
;GPIO = 0
	clrf	GPIO
	return

;********************************************************************************

INVERTE_SAIDA
;for auxa =1 to cnt
	clrf	AUXA
	movlw	1
	subwf	CNT,W
	btfss	STATUS, C
	goto	SysForLoopEnd3
SysForLoop3
	incf	AUXA,F
;wait 6 us
	movlw	2
	movwf	DELAYTEMP
DelayUS1
	decfsz	DELAYTEMP,F
	goto	DelayUS1
;next
	movf	CNT,W
	subwf	AUXA,W
	btfss	STATUS, C
	goto	SysForLoop3
SysForLoopEnd3
;piezo = piezo xor 1
	clrf	SysTemp1
	btfsc	GPIO,2
	incf	SysTemp1,F
	movlw	1
	xorwf	SysTemp1,F
	bcf	GPIO,2
	btfsc	SysTemp1,0
	bsf	GPIO,2
	return

;********************************************************************************

ISR_TIMER1
;TMR1H = 0Xd8 'carga para 10 ms
	movlw	216
	movwf	TMR1H
;TMR1L = 0Xef
	movlw	239
	movwf	TMR1L
;ger = ger + 1'//incrementa a cada 10 ms
	incf	GER,F
;if proc < 3 then 'gera 3 flash no grupo de leds 1
	movlw	3
	subwf	PROC,W
	btfsc	STATUS, C
	goto	ENDIF4
;select case ger
;case 1: gled1 = 1'liga grupo de leds 1
SysSelect1Case1
	decf	GER,W
	btfss	STATUS, Z
	goto	SysSelect1Case2
	bsf	GPIO,5
;case 4: gled1 = 0'desliga aps 30 ms
	goto	SysSelectEnd1
SysSelect1Case2
	movlw	4
	subwf	GER,W
	btfss	STATUS, Z
	goto	SysSelect1Case3
	bcf	GPIO,5
;case 11: proc = proc + 1 : ger = 0
	goto	SysSelectEnd1
SysSelect1Case3
	movlw	11
	subwf	GER,W
	btfss	STATUS, Z
	goto	SysSelectEnd1
	incf	PROC,F
	clrf	GER
;end select 'select case ger
SysSelectEnd1
;end if
ENDIF4
;if proc = 3 then
	movlw	3
	subwf	PROC,W
	btfss	STATUS, Z
	goto	ENDIF5
;if ger = 31 then 'intervalo de 300ms com leds apagados
	movlw	31
	subwf	GER,W
	btfss	STATUS, Z
	goto	ENDIF10
;proc = proc + 1
	incf	PROC,F
;ger = 0
	clrf	GER
;end if
ENDIF10
;end if
ENDIF5
;if ((proc > 3) and  (proc < 7)) then 'gera 3 flash no grupo de leds 2
	movf	PROC,W
	movwf	SysBYTETempB
	movlw	3
	movwf	SysBYTETempA
	call	SysCompLessThan
	movf	SysByteTempX,W
	movwf	SysTemp1
	movf	PROC,W
	movwf	SysBYTETempA
	movlw	7
	movwf	SysBYTETempB
	call	SysCompLessThan
	movf	SysByteTempX,W
	movwf	SysTemp2
	movf	SysTemp1,W
	andwf	SysTemp2,W
	movwf	SysTemp3
	btfss	SysTemp3,0
	goto	ENDIF6
;select case ger
;case 1: gled2 = 1'liga grupo de leds 2
SysSelect2Case1
	decf	GER,W
	btfss	STATUS, Z
	goto	SysSelect2Case2
	bsf	GPIO,4
;case 4: gled2 = 0'desliga aps 30 ms
	goto	SysSelectEnd2
SysSelect2Case2
	movlw	4
	subwf	GER,W
	btfss	STATUS, Z
	goto	SysSelect2Case3
	bcf	GPIO,4
;case 11: proc = proc +1 : ger = 0
	goto	SysSelectEnd2
SysSelect2Case3
	movlw	11
	subwf	GER,W
	btfss	STATUS, Z
	goto	SysSelectEnd2
	incf	PROC,F
	clrf	GER
;end select
SysSelectEnd2
;end if
ENDIF6
;if  proc = 7 then
	movlw	7
	subwf	PROC,W
	btfss	STATUS, Z
	goto	ENDIF7
;if ger = 31 then 'intervalo de 300ms com leds apagados
	movlw	31
	subwf	GER,W
	btfss	STATUS, Z
	goto	ENDIF11
;proc = proc +1
	incf	PROC,F
;ge r= 0
	clrf	GER
;end if
ENDIF11
;end if
ENDIF7
;if((proc > 7) and (proc < 11)) then 'gera 3 flash no grupo de leds 1 e 2
	movf	PROC,W
	movwf	SysBYTETempB
	movlw	7
	movwf	SysBYTETempA
	call	SysCompLessThan
	movf	SysByteTempX,W
	movwf	SysTemp1
	movf	PROC,W
	movwf	SysBYTETempA
	movlw	11
	movwf	SysBYTETempB
	call	SysCompLessThan
	movf	SysByteTempX,W
	movwf	SysTemp2
	movf	SysTemp1,W
	andwf	SysTemp2,W
	movwf	SysTemp3
	btfss	SysTemp3,0
	goto	ENDIF8
;select case ger
;case 1: gled1 = 1: gled2=1'liga grupo de leds 1
SysSelect3Case1
	decf	GER,W
	btfss	STATUS, Z
	goto	SysSelect3Case2
	bsf	GPIO,5
	bsf	GPIO,4
;case 4: gled1 = 0: gled2=0'desliga aps 30 ms
	goto	SysSelectEnd3
SysSelect3Case2
	movlw	4
	subwf	GER,W
	btfss	STATUS, Z
	goto	SysSelect3Case3
	bcf	GPIO,5
	bcf	GPIO,4
;case 11: proc = proc + 1: ger = 0
	goto	SysSelectEnd3
SysSelect3Case3
	movlw	11
	subwf	GER,W
	btfss	STATUS, Z
	goto	SysSelectEnd3
	incf	PROC,F
	clrf	GER
;end select
SysSelectEnd3
;end if
ENDIF8
;if proc = 11 then
	movlw	11
	subwf	PROC,W
	btfss	STATUS, Z
	goto	ENDIF9
;if ger = 31 then 'intervalo de 300ms com leds apagados
	movlw	31
	subwf	GER,W
	btfss	STATUS, Z
	goto	ENDIF12
;proc = 0;//finaliza ciclo
	clrf	PROC
;ge r= 0;
	clrf	GER
;end if
ENDIF12
;end if
ENDIF9
;TMR1IF=0
	bcf	PIR1,TMR1IF
	return

;********************************************************************************

SOM_SIRENE18
;sirene alarme rpido 1
;for auxd = 1  to 10   'numero de execues
;cnt = 40 'frequencia
	movlw	40
	movwf	CNT
;for auxc = 1 to 50   'passo
	clrf	AUXC
SysForLoop1
	incf	AUXC,F
;for auxb = 1 to 15  'permanncia
	clrf	AUXB
SysForLoop2
	incf	AUXB,F
;inverte_saida
	call	INVERTE_SAIDA
;next
	movlw	15
	subwf	AUXB,W
	btfss	STATUS, C
	goto	SysForLoop2
SysForLoopEnd2
;if cnt > 128 then
	movf	CNT,W
	sublw	128
	btfsc	STATUS, C
	goto	ELSE2_1
;cnt = cnt xor 0b10000000
	movlw	128
	xorwf	CNT,F
;else
	goto	ENDIF2
ELSE2_1
;cnt = cnt + 1
	incf	CNT,F
;end if
ENDIF2
;next
	movlw	50
	subwf	AUXC,W
	btfss	STATUS, C
	goto	SysForLoop1
SysForLoopEnd1
;next
	return

;********************************************************************************

SYSCOMPLESSTHAN
;Dim SysByteTempA, SysByteTempB, SysByteTempX as byte
;clrf SysByteTempX
	clrf	SYSBYTETEMPX
;bsf STATUS, C
	bsf	STATUS, C
;movf SysByteTempB, W
	movf	SYSBYTETEMPB, W
;subwf SysByteTempA, W
	subwf	SYSBYTETEMPA, W
;btfss STATUS, C
	btfss	STATUS, C
;comf SysByteTempX,F
	comf	SYSBYTETEMPX,F
	return

;********************************************************************************


 END
